%define	name	lvm2
%define	version	2.01.09
%define	release	1mdk

%define	build_lvm2cmd 0
%define	build_cluster 0
%{?_with_lvm2cmd: %{expand: %%global build_lvm2cmd 1}}
%{?_without_lvm2cmd: %{expand: %%global build_lvm2cmd 0}}
%{?_with_cluster: %{expand: %%global build_cluster 1}}
%{?_without_cluster: %{expand: %%global build_cluster 0}}

%if %build_lvm2cmd
%define	libname	%mklibname lvm2cmd 2
%define dlibname %mklibname -d lvm2cmd 2
%endif

%ifarch %{ix86} x86_64 ppc
%define	use_dietlibc 1
%else
%define	use_dietlibc 0
%endif

Summary:	Logical Volume Manager administration tools
Name:		%{name}
Version:	%{version}
Release:	%{release}
Source0:	ftp://sources.redhat.com/pub/lvm2/LVM2.%{version}.tar.bz2
Source1:	clvmd.init.bz2
Patch0:		lvm2-alternatives.patch.bz2
Patch1:		lvm2-diet.patch.bz2
Patch3:		lvm2-termcap.patch.bz2
Patch4:		lvm2-ignorelock.patch.bz2
Patch5:		lvm2-fdlog.patch.bz2
License:	GPL
Group:		System/Kernel and hardware
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
URL:		http://sources.redhat.com/lvm2/
BuildRequires:	device-mapper-devel >= 1.01
BuildRequires:	readline-devel
BuildRequires:	termcap-devel
Conflicts:	lvm
%if %{use_dietlibc}
BuildRequires:	dietlibc-devel
%else
BuildRequires:	glibc-static-devel
%endif

%description
LVM includes all of the support for handling read/write operations on
physical volumes (hard disks, RAID-Systems, magneto optical, etc.,
multiple devices (MD), see mdadm(8) or even loop devices, see losetup(8)),
creating volume groups (kind of virtual disks) from one or more physical
volumes and creating one or more logical volumes (kind of logical partitions)
in volume groups.

%if %build_lvm2cmd
%package -n	%{libname}
Summary:	LVM2 command line library
Group:		System/Kernel and hardware

%description -n	%{libname}
The lvm2 command line library allows building programs that manage
lvm devices without invoking a separate program.

%package -n	%{dlibname}
Summary:	Development files for LVM2 command line library
Group:		System/Kernel and hardware
Requires:	%{libname} = %{version}-%{release}
Provides:	%{libname}-devel = %{version}-%{release}
Provides:	%{mklibname -d lvm2cmd} = %{version}-%{release}
Provides:	lvm2cmd-devel = %{version}-%{release}

%description -n	%{dlibname}
The lvm2 command line library allows building programs that manage
lvm devices without invoking a separate program.
This package contains the header files for building with lvm2cmd.
%endif

%if %build_cluster
%package -n	clvmd
Summary:	cluster LVM daemon
Group:		System/Kernel and hardware
#BuildRequires:	dlm

%description -n	clvmd
clvmd  is  the  daemon  that  distributes LVM metadata updates around a
cluster.  It must be running on all nodes in the cluster and will  give
an error if a node in the cluster does not have this daemon running.
%endif

%prep
%setup -q -n LVM2.%{version}
%patch0 -p1 -b .alternatives
%patch1 -p1 -b .diet
%patch3 -p1 -b .termcap
%patch4 -p1 -b .ignorelock
%patch5 -p1 -b .fdlog

%build
autoconf # required by termcap patch
export ac_cv_lib_dl_dlopen=no
%configure --with-user=`id -un` --with-group=`id -gn` \
	--enable-static_link --disable-readline \
	--disable-selinux --with-cluster=none --with-pool=none
unset ac_cv_lib_dl_dlopen
%if %{use_dietlibc}
CC="diet gcc -DWRAPPER -D_BSD_SOURCE"
LVMLIBS="-llvm -ldevmapper-diet"
%else
CC="gcc -DWRAPPER"
LVMLIBS="-static -llvm -ldevmapper"
%endif
%make CC="$CC" LVMLIBS="$LVMLIBS"
cd tools
$CC -o lvm-static lvm.o lvmcmdline.o vgchange.o vgscan.o archiver.o toollib.o vgmknodes.o pvmove.o polldaemon.o -L ../lib $LVMLIBS
cd ..
%make clean
%configure --with-user=`id -un` --with-group=`id -gn` \
	--disable-static_link --enable-readline \
	--disable-selinux --enable-lvm1_fallback \
	--enable-fsadm --enable-nls --with-pool=internal \
%if %build_lvm2cmd
	--enable-cmdlib \
%endif
%if %build_cluster
	--with-clvmd=cman --with-cluster=shared \
%endif
# end of configure options
%make

%install
rm -rf %{buildroot}
%makeinstall sbindir=%{buildroot}/sbin confdir=%{buildroot}%{_sysconfdir}/lvm

rm -f %{buildroot}/sbin/lvm %{buildroot}%{_mandir}/man8/lvm.8 # so it's not found when creating lvm2-setup-alternatives.sh

echo "update-alternatives --install /sbin/lvm lvm /sbin/lvm2 20 \\" > lvm2-setup-alternatives.sh

for i in ${RPM_BUILD_ROOT}/sbin/*; do
	n=${i##*/} # basename
	rm -f $i
	echo "--slave /sbin/$n $n /sbin/lvm2 \\" >> lvm2-setup-alternatives.sh
done
echo "--slave %{_mandir}/man8/lvm.8.bz2 lvm.8 %{_mandir}/man8/lvm2.8.bz2 \\" >> lvm2-setup-alternatives.sh
for i in ${RPM_BUILD_ROOT}%{_mandir}/man8/*; do
	n=${i##*/} # basename
	mv $i ${RPM_BUILD_ROOT}%{_mandir}/man8/lvm2-$n
	echo "--slave %{_mandir}/man8/$n.bz2 $n %{_mandir}/man8/lvm2-$n.bz2 \\" >> lvm2-setup-alternatives.sh
done
echo >> lvm2-setup-alternatives.sh
#"

install tools/lvm %{buildroot}/sbin/lvm2
install tools/lvm-static %{buildroot}/sbin/lvm2-static
cp -p man/lvm.8 %{buildroot}%{_mandir}/man8/lvm2.8
install tools/fsadm/fsadm %{buildroot}/sbin

%find_lang %name

%post -f lvm2-setup-alternatives.sh

%if %build_lvm2cmd
%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig
%endif

%postun
if [ $1 = 0 ]; then
	update-alternatives --remove lvm /sbin/lvm2
fi

%clean
rm -rf %{buildroot}

%files -f %name.lang
%defattr(644,root,root,755)
%attr(755,root,root) /sbin/lvm2
%attr(755,root,root) /sbin/lvm2-static
%attr(755,root,root) /sbin/fsadm
#{_libdir}/liblvm2format1.so*
#{_libdir}/liblvm2formatpool.so*
#{_libdir}/liblvm2mirror.so*
#{_libdir}/liblvm2snapshot.so*
%dir %{_sysconfdir}/lvm/
%config(noreplace) %{_sysconfdir}/lvm/lvm.conf
%{_mandir}/man5/*
%{_mandir}/man8/*
%doc INSTALL README VERSION WHATS_NEW

%if %build_lvm2cmd
%files -n %{libname}
%defattr(644,root,root,755)
%{_libdir}/liblvm2cmd.so*

%files -n %{dlibname}
%defattr(644,root,root,755)
%{_includedir}/lvm2cmd.h
%attr(755,root,root) %{_libdir}/liblvm2cmd.so
%endif
%if %build_cluster
%files -n clvmd
%defattr(755, root,root)
%config(noreplace) %{_initrddir}/clvmd
%{_sbindir}/clvmd
%{_libdir}/liblvm2clusterlock.so*
%attr(644,root,root) %{_mandir}/man8/clvmd.8*
%endif


%changelog
* Sun Apr 17 2005 Luca Berra <bluca@vodka.it> 2.01.09-1mdk 
- 2.01.09
- part of p4 (ignorelockingfailure) was merged
- rediffed p5 (File descriptor left open)
- added support for GFS pool format
- added cluster build option and clvmd subpackage

* Tue Apr 05 2005 Luca Berra <bluca@vodka.it> 2.00.33-4mdk 
- add --ignorelockingfailure to vgmknodes (p4)
- silence annoyng "File descriptor left open" messages (p5)

* Sat Mar 05 2005 Luca Berra <bluca@vodka.it> 2.00.33-3mdk 
- remove require for libdevmapper1.00

* Sat Mar 05 2005 Luca Berra <bluca@vodka.it> 2.00.33-2mdk 
- rebuild for new libdevmapper

* Sat Jan 29 2005 Luca Berra <bluca@vodka.it> 2.00.33-1mdk 
- 2.00.33

* Thu Jan 20 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.00.32-2mdk
- rebuild for new readline

* Sat Jan 15 2005 Luca Berra <bluca@vodka.it> 2.00.32-1mdk 
- 2.0.32
- do not link static binary with libdl

* Fri Dec 24 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.00.31-1mdk
- 2.00.31
- cosmetics

* Sun Nov 28 2004 Luca Berra <bluca@vodka.it> 2.00.27-1mdk 
- 2.0.27

* Sun Nov 14 2004 Luca Berra <bluca@vodka.it> 2.00.25-1mdk 
- 2.0.25
- added fsadm
- enabled nls
- added support for building the command line library

* Tue Sep  7 2004 Luca Berra <bluca@mandrakesoft.com> 2.00.22-1mdk
- 2.00.22
- define _BSD_SOURCE when building with dietlibc
- drop p4 no longer needed

* Sun Aug 01 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 2.00.20-2mdk
- use dietlibc for static build on ppc as well
- add BuildRequires: glibc-static-devel for other archs

* Thu Jul 22 2004 Luca Berra <bluca@vodka.it> 2.00.20-1mdk 
- 2.00.20
- disabled selinux build
- added workaround for including fs.h with glibc 2.3.3 (p4)

* Tue Jun 29 2004 Luca Berra <bluca@vodka.it> 2.00.19-2mdk 
- really fix alternatives patch

* Tue Jun 29 2004 Luca Berra <bluca@vodka.it> 2.00.19-1mdk 
- 2.00.19
- rediffed p0 (alternatives) and p1 (diet)
 
* Mon May 24 2004 Luca Berra <bluca@vodka.it> 2.00.16-1mdk 
- 2.00.16

* Sat Apr 17 2004 Luca Berra <bluca@vodka.it> 2.00.14-1mdk 
- 2.00.14
- rediffed p0, p1, p3
- removed p2, p4, p5 merged upstream

* Sun Jan 25 2004 Luca Berra <bluca@vodka.it> 2.00.08-8mdk 
- patch to ignore devices that have an md superblock on them

* Fri Jan 23 2004 Luca Berra <bluca@vodka.it> 2.00.08-7mdk
- patch to fix uidless PVs created during 9.2 installation

* Sun Jan 04 2004 Luca Berra <bluca@vodka.it> 2.00.08-6mdk
- DIRM: /etc/lvm
- build vs termcap, not ncurses

* Tue Dec 29 2003 Stefan van der Eijk <stefan@eijk.nu> 2.00.08-5mdk
- BuildRequires

* Sat Dec 20 2003 Luca Berra <bluca@vodka.it> 2.00.08-4mdk
- fix annoying "setlocale failed" message in dietlibc version

* Sun Dec 14 2003 Luca Berra <bluca@vodka.it> 2.00.08-3mdk
- added vgmknodes to static/diet binary
- imported blksize64 patch from fedora
- use %%post -f for alternatives script
- lvm.conf is a config file

* Sat Nov 22 2003 Luca Berra <bluca@vodka.it> 2.00.08-2mdk
- built against device-mapper 1.00.07

* Thu Nov 20 2003 Luca Berra <bluca@vodka.it> 2.00.08-1mdk
- 2.0.08 stable
- added static/dietlibc version for initrd

* Tue Sep 16 2003 Luca Berra <bluca@vodka.it> 2.00.07-1mdk
- 2.00.07 stable

* Sat Sep 06 2003 Luca Berra <bluca@vodka.it> 2.00.06-1mdk
- accept lvm2 as a valid command name

* Sun Jul 27 2003 Luca Berra <bluca@vodka.it> 2.00.06-0.1mdk
- 2.00.06 stable
- mdk uses bzip2

* Sun Jul 27 2003 Luca Berra <bluca@vodka.it> 2.00.05-0.1mdk
- 2.00.05 stable

* Sun Dec  1 2002 Luca Berra <bluca@vodka.it> 1.95.10-2mdk
- use alternatives for compatibility with lvm1

* Sat Jun  1 2002 Luca Berra <bluca@vodka.it> 1.95.10-1mdk
- 1.95.10
